#ifndef _JSTK_CLIENT_H_
#define _JSTK_CLIENT_H_

#include "pktIO.h"

struct reflex;

/*------------------------------------------------------------*/
/*                     public interface                       */
/*------------------------------------------------------------*/

#ifdef __cplusplus
extern "C"
{
#endif

  struct reflexJoystick {
    int port;
    
    int (*stateRpl) (struct reflex *reflex, int rv, unsigned char id, int ts,
		     int x, int y, unsigned char buttons);
    
    int (*unknownRpl) (struct reflex *reflex, unsigned char id,
		       unsigned char size,
		       unsigned char *buffer, unsigned char opcode);
    
    /* ---------------------------------------- */

    int (*stateReq) (struct reflex *reflex, unsigned char id);
    
    /* ---------------------------------------- */

    int (*handlePort) (struct reflex *reflex, int size, unsigned char *buffer,
		       unsigned char id, unsigned char opcode);
    
    int (*destroy)    (struct reflexJoystick *ptr);
  };

  struct reflexJoystick * reflexJoystickNew (int port);
#ifdef __cplusplus
}
#endif

/*============================================================*/

#define JSTK_GET_STATE           0

#endif
